#import "ShareContentFacebookPlugin.h"

#import "FBSDKShareKit.h"
//#import <FBSDKShareKit/FBSDKShareDialog.h>
//#import <FBSDKShareKit/FBSDKShareLinkContent.h>
//#import <FBSDKShareKit/FBSDKMessageDialog.h>

@implementation ShareContentFacebookPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"share_content_facebook"
            binaryMessenger:[registrar messenger]];
  ShareContentFacebookPlugin* instance = [[ShareContentFacebookPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}
  
- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    NSString *method = call.method;
    
       
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  } else if ([@"shareContent" isEqualToString:call.method]) {
     NSString *url = call.arguments[@"url"];
     NSString *quote = call.arguments[@"quote"];
     NSString *hashTag = call.arguments[@"hashTag"];
      
     FBSDKShareLinkContent *content = [[FBSDKShareLinkContent alloc] init];
      if(url.length != 0){
          content.contentURL = [NSURL URLWithString: url];
      }
      
      if(quote.length != 0){
          content.quote = quote;
      }
      
      if(hashTag.length != 0){
          content.hashtag = [FBSDKHashtag hashtagWithString:hashTag];
      }
     
     self.resultHandler = result;
     FBSDKShareDialog *dialog = [[FBSDKShareDialog alloc] init];
     
     if ([UIApplication sharedApplication].keyWindow.rootViewController == (id)[NSNull null] )  {
         UIStoryboard *sb = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
         UIViewController *vc = [sb instantiateViewControllerWithIdentifier:@"FlutterViewController"];
         UIWindow *window = [UIApplication sharedApplication].delegate.window;
         UINavigationController *x = [[UINavigationController alloc] initWithRootViewController:vc];
         window.rootViewController = x;
         dialog.fromViewController = x;
     } else {
         dialog.fromViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
     }
     
     
     dialog.shareContent = content;
     dialog.delegate = self;
     dialog.mode = FBSDKShareDialogModeAutomatic;
     
     [dialog show];

 } else if ([@"sharePhoto" isEqualToString:call.method]) {
     NSArray *pathImage = call.arguments[@"pathImage"];
     NSString *path = call.arguments[@"path"];

     //[self imagePickerController:picker result:result pathImage:pathImage path:path];
     
     NSData *data = [NSPropertyListSerialization dataWithPropertyList:pathImage format:NSPropertyListBinaryFormat_v1_0 options:0 error:nil];
     //UIImage *image = [UIImage imageWithData:data];
     UIImage *image = [[UIImage alloc] initWithData:data];
     
     FBSDKSharePhoto *photo = [[FBSDKSharePhoto alloc] init];
     photo.image = image;
     photo.userGenerated = YES;
     FBSDKSharePhotoContent *content = [[FBSDKSharePhotoContent alloc] init];
     content.photos = @[photo];
     self.resultHandler = result;
     
     FBSDKShareDialog *dialog = [[FBSDKShareDialog alloc] init];

     if ([UIApplication sharedApplication].keyWindow.rootViewController == (id)[NSNull null] )  {
         UIStoryboard *sb = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
         UIViewController *vc = [sb instantiateViewControllerWithIdentifier:@"FlutterViewController"];
         UIWindow *window = [UIApplication sharedApplication].delegate.window;
         UINavigationController *x = [[UINavigationController alloc] initWithRootViewController:vc];
         window.rootViewController = x;
         dialog.fromViewController = x;
     } else {
         dialog.fromViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
     }
   

     dialog.shareContent = content;
     dialog.delegate = self;
     dialog.mode = FBSDKShareDialogModeAutomatic;

     [dialog show];
   
 } else {
     result(FlutterMethodNotImplemented);
 }
}



- (void)imagePickerController:(UIImagePickerController *)picker result:(FlutterResult)result pathImage:(NSArray*)pathImage path:(NSString*)path
{
    NSData *data = [NSPropertyListSerialization dataWithPropertyList:pathImage format:NSPropertyListBinaryFormat_v1_0 options:0 error:nil];
    UIImage *image = [UIImage imageWithData:data];
    
    //printf("%f",image.size.width);
    
    FBSDKSharePhoto *photo = [[FBSDKSharePhoto alloc] init];
    photo.image = image;
    photo.userGenerated = YES;
    FBSDKSharePhotoContent *content = [[FBSDKSharePhotoContent alloc] init];
    content.photos = @[photo];
    self.resultHandler = result;
    FBSDKShareDialog *dialog = [[FBSDKShareDialog alloc] init];

    if ([UIApplication sharedApplication].keyWindow.rootViewController == (id)[NSNull null] )  {
        UIStoryboard *sb = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
        UIViewController *vc = [sb instantiateViewControllerWithIdentifier:@"FlutterViewController"];
        UIWindow *window = [UIApplication sharedApplication].delegate.window;
        UINavigationController *x = [[UINavigationController alloc] initWithRootViewController:vc];
        window.rootViewController = x;
        dialog.fromViewController = x;
    } else {
        dialog.fromViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    }


    dialog.shareContent = content;
    dialog.delegate = self;
    dialog.mode = FBSDKShareDialogModeAutomatic;

    [dialog show];
  
}


- (void)sharer:(id<FBSDKSharing>)sharer didCompleteWithResults:(NSDictionary *)results{
    self.resultHandler(@YES);
    self.resultHandler = nil;
}

- (void)sharerDidCancel:(id<FBSDKSharing>)sharer {
    self.resultHandler(@NO);
    self.resultHandler = nil;
}

- (void)sharer:(id<FBSDKSharing>)sharer didFailWithError:(NSError *)error {
    self.resultHandler([FlutterError errorWithCode:@"unavailable"
                                           message:error.localizedDescription
                                           details:nil]);
    self.resultHandler = nil;
}

@end
