import 'dart:async';
import 'dart:typed_data';
import 'dart:ui' as ui;
import 'package:flutter/services.dart';

class ShareContentFacebook {
  static const MethodChannel _channel =
  const MethodChannel('share_content_facebook');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<bool> shareContent({String url = "", String quote = "", String hashTag = ""}) async {

    final bool succeeded = await _channel.invokeMethod(
        'shareContent', {"url": url, "quote": quote,"hashTag":hashTag});
    return succeeded;
  }

  static Future<bool> sharePhoto({String pathImage = ""}) async {
    ByteData data = await rootBundle.load(pathImage);
    Uint8List img = new Uint8List.view(data.buffer);

    final bool succeeded = await _channel.invokeMethod(
        'sharePhoto', {"pathImage":img,"path":pathImage});
    return succeeded;
  }

}